// Copyright (C) 1999 Ingo Ruhnke <grumbel@gmx.de>, see README.TXT for details

#include "counter.hh"

Counter::Counter()
{
  size = 8;
  count = 0;
}

Counter::Counter(int s)
{
  size = s;
  count = 0;
}

int
Counter::operator++()
{
  return Counter::inc();
}


int
Counter::operator--()
{
 --count;

 if (count < 0) {
   count = size - 1;
 }
 return count;
}

int 
Counter::inc()
{
  ++count;
  
  if (count >= size) {
    count = 0;
  }
  
  return count;
}

int
Counter::get_value()
{
  return count;
}

int
Counter::set_count(int i)
{
  return count = i;
}

int
Counter::set_size(int s)
{
  size = s;
  if (count > size || count < 0) {
    count = 0;
  }
}

/* EOF */
