// Copyright (C) 1998 Ingo Ruhnke <grumbel@gmx.de>, see README.TXT for details

#include <iostream>
#include <stdio.h>

#include "pingu.hh"
#include "mouse.hh"
#include "pingu.hh"
#include "playfield.hh"
#include "plf.hh"

CL_Surface* Playfield::cap;

Playfield::Playfield()
{
  cout << "Playfield:init" << endl;
  current_pingu = 0;
  x_offset = 0;
  y_offset = 0;
}

Playfield::Playfield(PLF* level_data)
{
  world.init(level_data);
  current_pingu = 0;
  pingu = world.get_pingu_p();
  x_offset = 0;
  y_offset = 0;
}

Playfield::~Playfield()
{
}

void
Playfield::draw()
{
  // draw the world (Playfield, pingus, ...)
  //  x_offset = 100;
  //  y_offset = 0;
  world.draw_offset(x_offset, y_offset);

  // draw the capture rectange
  for (int i=0; i < pingu->size(); ++i) {
    //    cout << "Pingus: " << i << " " << (*pingu)[i].get_x() << " " << (*pingu)[i].get_y() << endl;
    if ((*pingu)[i]->is_over(Mouse::get_x()-+x_offset, Mouse::get_y()-y_offset)) {
      cap->put_screen((*pingu)[i]->get_x()-17+x_offset, (*pingu)[i]->get_y()-33+y_offset);
      current_pingu = i;
      break;
    } else {
      current_pingu = -1;
    }
  }
}

void
Playfield::let_move()
{
  // Let the playfield scroll around
  if (CL_Keyboard::get_keycode(CL_Keyboard::KEY_LEFT) == true) {
    x_offset += 10;
  } else if (CL_Keyboard::get_keycode(CL_Keyboard::KEY_RIGHT) == true) {
    x_offset -= 10;
  }

  if (CL_Keyboard::get_keycode(CL_Keyboard::KEY_UP) == true) {
    y_offset += 10;
  } else if (CL_Keyboard::get_keycode(CL_Keyboard::KEY_DOWN) == true) {
    y_offset -= 10;
  }



  world.let_move();

  if (current_pingu != -1 && Mouse::is_pressed(0)) {
    (*pingu)[current_pingu]->set_action(buttons->get_action());
  }
}

void
Playfield::load_data(CL_ResourceManager* resource)
{
  cap = CL_Res_Surface::load("Game/cap", *resource);

  if (!cap) {
    cout << "Couldn't load cap" << endl;
    exit(EXIT_FAILURE);
  }
}

void
Playfield::set_buttons(ButtonPanel* b)
{
  buttons = b;
}

/* EOF */

